## ring 20210112.2.b757bac~ds1

=== daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(ring-daemon C CXX)

################################################################################
# Source groups
################################################################################

# compat, src source group

add_subdirectory("compat")
add_subdirectory("src")

source_group("Source Files" FILES ${Source_Files})
source_group("Source Files\\client" FILES ${Source_Files__client})
source_group("Source Files\\config" FILES ${Source_Files__config})
source_group("Source Files\\dring" FILES ${Source_Files__dring})
source_group("Source Files\\hooks" FILES ${Source_Files__hooks})
source_group("Source Files\\im" FILES ${Source_Files__im})
source_group("Source Files\\jamidht" FILES ${Source_Files__jamidht})
source_group("Source Files\\jamidht\\eth\\libdevcore" FILES ${Source_Files__jamidht__eth__libdevcore})
source_group("Source Files\\jamidht\\eth\\libdevcrypto" FILES ${Source_Files__jamidht__eth__libdevcrypto})
source_group("Source Files\\media" FILES ${Source_Files__media})
source_group("Source Files\\media\\audio" FILES ${Source_Files__media__audio})
source_group("Source Files\\media\\audio\\sound" FILES ${Source_Files__media__audio__sound})
source_group("Source Files\\media\\video" FILES ${Source_Files__media__video})
source_group("Source Files\\plugin" FILES ${Source_Files__plugin})

if(MSVC)
   if(WINDOWS_STORE)
      source_group("Source Files\\media\\video\\uwpvideo" FILES ${Source_Files__media__video__uwpvideo})
   endif()
   source_group("Source Files\\media\\audio\\portaudio" FILES ${Source_Files__media__audio__portaudio})
   source_group("Source Files\\media\\video\\winvideo" FILES ${Source_Files__media__video__winvideo})
endif()

source_group("Source Files\\security" FILES ${Source_Files__security})
source_group("Source Files\\sip" FILES ${Source_Files__sip})
source_group("Source Files\\upnp" FILES ${Source_Files__upnp})
source_group("Source Files\\upnp\\protocol" FILES ${Source_Files__upnp__protocol})
source_group("Source Files\\upnp\\protocol\\natpmp" FILES ${Source_Files__upnp__protocol__natpmp})
source_group("Source Files\\upnp\\protocol\\pupnp" FILES ${Source_Files__upnp__protocol__pupnp})

list (APPEND ALL_FILES
      ${Source_Files}
      ${Source_Files__client}
      ${Source_Files__config}
      ${Source_Files__dring}
      ${Source_Files__hooks}
      ${Source_Files__im}
      ${Source_Files__jamidht}
      ${Source_Files__jamidht__eth__libdevcore}
      ${Source_Files__jamidht__eth__libdevcrypto}
      ${Source_Files__media}
      ${Source_Files__media__audio}
      ${Source_Files__media__audio__sound}
      ${Source_Files__media__video}
      ${Source_Files__security}
      ${Source_Files__sip}
      ${Source_Files__upnp}
      ${Source_Files__upnp__protocol}
      ${Source_Files__upnp__protocol__natpmp}
      ${Source_Files__upnp__protocol__pupnp}
      ${Source_Files__plugin}
)

if(MSVC)
   list (APPEND ALL_FILES ${ALL_FILES}
         "${Source_Files__media__audio__portaudio}"
         "${Source_Files__media__video__uwpvideo}"
         "${Source_Files__media__video__winvideo}"
   )

   ################################################################################
   # Target
   ################################################################################
   include("CMake/Utils.cmake")

   add_library(${PROJECT_NAME} STATIC ${ALL_FILES})
   set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "daemon")

   use_props(${PROJECT_NAME} "${CMAKE_CONFIGURATION_TYPES}" "${DEFAULT_CXX_PROPS}")

   set_target_properties (${PROJECT_NAME} PROPERTIES CXX_STANDARD 17)

   ################################################################################
   # Include necessary .cmake file (need to init use_props first)
   ################################################################################
   include("CMake/Default.cmake")
   include("CMake/DefaultCXX.cmake")

   set(ROOT_NAMESPACE ringdaemon)

   ################################################################################
   # Target name
   ################################################################################
   if("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "x64")
       set_target_properties(${PROJECT_NAME} PROPERTIES
           TARGET_NAME_RELEASELIB_WIN32 "dring"
       )
   endif()
   ################################################################################
   # Output directory
   ################################################################################
   if("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "x64")
       set_target_properties(${PROJECT_NAME} PROPERTIES
           OUTPUT_DIRECTORY_RELEASELIB_WIN32 "${CMAKE_CURRENT_SOURCE_DIR}/build/${CMAKE_VS_PLATFORM_NAME}/$<CONFIG>/bin/"
       )
   endif()
   if("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "x64")
       set_target_properties(${PROJECT_NAME} PROPERTIES
           INTERPROCEDURAL_OPTIMIZATION_RELEASELIB_WIN32 "FALSE"
       )
   endif()
   ################################################################################
   # Include directories
   ################################################################################
   if("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "x64")
       target_include_directories(${PROJECT_NAME} PUBLIC
           "$<$<CONFIG:ReleaseLib_win32>:"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/include/upnp;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/include;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/sndfile/src;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/openssl/include;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/asio/asio/include;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/restinio/dev;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/fmt/include;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/http_parser;"
               "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/natpmp"
           ">"
           "${CMAKE_CURRENT_SOURCE_DIR}/.;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/client;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/config;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/dring;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/hooks;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/im;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/media;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/jamidht;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/security;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/sip;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/upnp;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/upnp/igd;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/upnp/protocol;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/upnp/mapping;"
           "${CMAKE_CURRENT_SOURCE_DIR}/src/jamidht/eth;"
           "${CMAKE_CURRENT_SOURCE_DIR}/compat/msvc;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/msgpack-c/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/opendht/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/libarchive/libarchive;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/jsoncpp/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/yaml-cpp/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/pjlib/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/pjnath/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/pjlib-util/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/pjsip/include;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/third_party;"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/pjmedia/include"
           "${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/speexdsp/include;"
       )
   endif()

   ################################################################################
   # Compile definitions
   ################################################################################
   if("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "x64")
       target_compile_definitions(${PROJECT_NAME} PRIVATE
           "$<$<CONFIG:ReleaseLib_win32>:"
               "_WIN32_WINNT=0x0A00;"
               "ASIO_STANDALONE;"
               "STATIC_GETOPT;"
               "LIBARCHIVE_STATIC;"
               "OPENDHT_PROXY_CLIENT;"
               "OPENDHT_PROXY_SERVER;"
               "OPENDHT_PUSH_NOTIFICATIONS;"
               "NATPMP_STATICLIB;"
               "ENABLE_PLUGIN;"
               "NDEBUG;"
           ">"
           "_USE_MATH_DEFINES;"
           "_SCL_SECURE_NO_WARNINGS;"
           "_CRT_SECURE_NO_WARNINGS;"
           "NOMINMAX;"
           "HAVE_CONFIG_H;"
           "WIN32_LEAN_AND_MEAN;"
       )
   endif()

   ################################################################################
   # Compile and link options
   ################################################################################
   if("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "x64")
       target_compile_options(${PROJECT_NAME} PRIVATE
           $<$<CONFIG:ReleaseLib_win32>:
               /O2;
               /Oi;
               ${DEFAULT_CXX_RUNTIME_LIBRARY};
               /Gy;
               /MP;
               /Oy-;
               /sdl-;
               /W0;
               /FC;
               /FS
           >
           /nologo;
           /Zi;
           /wd4996;
           /wd4503;
           /wd4180;
           /wd4244;
           /wd4267;
           ${DEFAULT_CXX_EXCEPTION_HANDLING}
       )
   endif()
   if("${CMAKE_VS_PLATFORM_NAME}" STREQUAL "x64")
       target_link_options(${PROJECT_NAME} PRIVATE
           $<$<CONFIG:ReleaseLib_win32>:
               /MACHINE:X86;
               /OPT:REF;
               /OPT:ICF
           >
           /VERBOSE:LIB;
           /NODEFAULTLIB:libcmtd;
           /NODEFAULTLIB:libcmt;
           /OPT:NOLBR;
           /OPT:NOICF;
           /LTCG
       )
   endif()

   ################################################################################
   # Dependencies
   ################################################################################

   set(libAdditionalDependencies "${CMAKE_STATIC_LINKER_FLAGS} /LTCG
   ws2_32.lib 
   advapi32.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/bin/avcodec.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/bin/avdevice.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/bin/avfilter.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/bin/avformat.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/bin/avutil.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/bin/swresample.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/ffmpeg/Build/win32/x64/bin/swscale.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/lib/x64/libgnutls.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/lib/x64/lib_json.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/opendht/build/Release/libopendht.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/argon2/vs2015/Argon2Ref/vs2015/build/Argon2Ref.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/lib/x64/secp256k1.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/yaml-cpp/msvc/Release/libyaml-cppmd.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/lib/x64/portaudio.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/lib/x64/libupnp.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/natpmp/msvc/Release/natpmp.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/msvc/lib/x64/archive_static.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/pjsip/lib/pjsip-core-x86_64-x64-vc15-Release.lib 
   ${CMAKE_CURRENT_SOURCE_DIR}/contrib/build/pjproject/pjsip/lib/pjsip-simple-x86_64-x64-vc15-Release.lib

=== lrc/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.5.1)

IF(POLICY CMP0022)
   CMAKE_POLICY(SET CMP0022 NEW)
ENDIF(POLICY CMP0022)

IF(POLICY CMP0043)
   CMAKE_POLICY(SET CMP0043 NEW)
ENDIF(POLICY CMP0043)

IF(POLICY CMP0020)
   CMAKE_POLICY(SET CMP0020 NEW)
ENDIF(POLICY CMP0020)

IF(POLICY CMP0063)
   CMAKE_POLICY(SET CMP0063 NEW)
ENDIF(POLICY CMP0063)

INCLUDE(GNUInstallDirs)
INCLUDE(CMakePackageConfigHelpers)
INCLUDE(GenerateExportHeader)

option (ENABLE_SHARED "Build shared library" ON)

string(SUBSTRING ${CMAKE_GENERATOR} 0 14 CMAKE_GENERATOR_SHORT)
if(CMAKE_GENERATOR_SHORT MATCHES "Visual Studio ")
    message(STATUS "Generating VS project")
    set(CMAKE_CXX_COMPILER_ID "MSVC")
    set(ENABLE_TEST false)
    set(ENABLE_STATIC true)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi /W0 /MP")
endif()

if (NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
    ADD_DEFINITIONS(
       ${QT_DEFINITIONS}
       -fexceptions
       -O2
    )
endif()

# Options
set(CHK_FREEABLE_BEFORE_ERASE_ACCOUNT_DESCRIPTION
"Check that an account has been marked freeable by the client
before freeing the structures. This avoids various race
conditions while removing accounts but may not be supported by
all clients. ON by default on Linux systems, otherwise OFF.")

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  option (CHK_FREEABLE_BEFORE_ERASE_ACCOUNT CHK_FREEABLE_BEFORE_ERASE_ACCOUNT_DESCRIPTION ON)
ELSE()
  option (CHK_FREEABLE_BEFORE_ERASE_ACCOUNT CHK_FREEABLE_BEFORE_ERASE_ACCOUNT_DESCRIPTION OFF)
ENDIF()

PROJECT(ringclient)

# First, check is the compiler is new enough, most version of Clang are fine
# until problems arise, checking for GCC is enough
IF (CMAKE_COMPILER_IS_GNUCC)
   EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
   IF (GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
      MESSAGE(STATUS "Found GCC version >= 4.8: " ${GCC_VERSION})
   ELSE()
      MESSAGE(FATAL_ERROR "Your version of GCC is too old, please install GCC 4.8 or later")
   ENDIF()
ENDIF()

SET(CMAKE_CXX_STANDARD 17)
SET(CXX_STANDARD_REQUIRED TRUE)

SET(CMAKE_AUTOMOC TRUE)

SET(LOCAL_CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/")
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${LOCAL_CMAKE_MODULE_PATH})

FIND_PACKAGE(Ring REQUIRED)

if(QT5_VER AND QT5_PATH)
   string(REPLACE "." ";" VERSION_LIST ${QT5_VER})
   list(GET VERSION_LIST 0 QT5_VER_MAJOR)
   list(GET VERSION_LIST 1 QT5_VER_MINOR)
   list(GET VERSION_LIST 2 QT5_VER_PATCH)

   if ((${QT5_VER_MAJOR} GREATER_EQUAL 5) AND (${QT5_VER_MINOR} GREATER_EQUAL 14))
      message(STATUS "Using custom Qt version")
      find_package(Qt5 ${QT5_VER} REQUIRED
                  COMPONENTS Core DBus Sql Gui
                  PATHS ${QT5_PATH} NO_DEFAULT_PATH)
      # Linguist tools is not required.
      find_package(Qt5 ${QT5_VER}
                  COMPONENTS LinguistTools
                  PATHS ${QT5_PATH} NO_DEFAULT_PATH)
      set(CMAKE_INSTALL_RPATH_USE_LINK_PATH true)
   endif()
else()
   find_package(Qt5 REQUIRED
                COMPONENTS Core DBus Sql Gui)
   # Linguist tools is not required.
   find_package(Qt5LinguistTools)
endif()

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT ENABLE_LIBWRAP)
   FIND_PACKAGE(Qt5DBus)
ELSE()
   SET(ENABLE_LIBWRAP true)
ENDIF()


IF(NOT ENABLE_TEST)
  SET(ENABLE_TEST false)
ENDIF()


IF((${ENABLE_TEST} MATCHES true))
  SET(ENABLE_LIBWRAP true) # because mocks use the same interface present in src/qtwrapper
ENDIF()

if (NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
# Enable some useful warnings
    ADD_DEFINITIONS(
       -Wall
       -Wextra
       -Wmissing-declarations
       -Wmissing-noreturn
       -Wpointer-arith
       -Wcast-align
       -Wwrite-strings
       -Wformat-nonliteral
       -Wformat-security
       -Wswitch-enum
       -Winit-self
       -Wmissing-include-dirs
       -Wundef
       -Wmissing-format-attribute
       -Wno-reorder
       -Wunused
       -Wuninitialized
       -Woverloaded-virtual
       -Wunused-value
       -pedantic
       -Wnonnull
       -Wsequence-point
       #-Wsystem-headers
       -Wsizeof-pointer-memaccess
       #-Wuseless-cast
       -Wvarargs

       #See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=55578
       -Wno-unused-function
       -Wno-attributes
    )
endif()

#Add more warnings for compilers that support it. I used this command:
#curl https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gcc/Warning-Options.html | \
#grep -E "^[\t ]+<br><dt><code>-W[a-zA-Z=-]*" -o | grep -E "\-W[a-zA-Z=-]*" -o >
#cat /tmp/48 /tmp/49 | sort | uniq -u
# IF (CMAKE_COMPILER_IS_GNUCC)

IF (CMAKE_COMPILER_IS_GNUCC)
   IF (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
      ADD_DEFINITIONS(
         -Wunused-but-set-parameter
         -Wconditionally-supported
         #-Wsuggest-attribute=const
         -Wno-cpp
         -Wdouble-promotion
         -Wdate-time
         -Wdelete-incomplete
         -Wfloat-conversion
      )
   ENDIF()

   if (GCC_VERSION VERSION_GREATER 5.1 OR GCC_VERSION VERSION_EQUAL 5.1)
      ADD_DEFINITIONS(
         #-Wsuggest-override
         #-Wsuggest-final-types
         #-Wsuggest-final-methods
         -Wbool-compare
         -Wformat-signedness
         -Wlogical-not-parentheses
         -Wnormalized
         -Wshift-count-negative
         -Wshift-count-overflow
         -Wsized-deallocation
         -Wsizeof-array-argument
      )
   ENDIF()

   IF (GCC_VERSION VERSION_GREATER 6.0 OR GCC_VERSION VERSION_EQUAL 6.0)
      ADD_DEFINITIONS(
         -Wnull-dereference
         -Wshift-negative-value
         -Wshift-overflow
         -Wduplicated-cond
         -Wmisleading-indentation
      )
   ENDIF()
ENDIF()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   ADD_DEFINITIONS(
      -Wno-c++98-compat
      -Wno-c++98-compat-pedantic
      -Wno-unknown-pragmas
      -Wno-documentation-unknown-command
      -Wno-padded
      -Wno-old-style-cast
      -Wno-sign-conversion
      -Wno-exit-time-destructors
      -Wno-global-constructors
      -Wno-shorten-64-to-32
      #-Weverything
   )
endif()

# OS X
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

   SET(CMAKE_MACOSX_RPATH ON)
   SET(CMAKE_SKIP_BUILD_RPATH FALSE)
   SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
   SET(CMAKE_INSTALL_RPATH "${CMAKE_CURRENT_SOURCE_DIR}")
   SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

IF(${ENABLE_LIBWRAP} MATCHES true)
   # The daemon is only required for when using direct linking
   IF (${RING_FOUND} MATCHES "false")
      MESSAGE(FATAL_ERROR "The daemon is required")
   ENDIF()

   ADD_SUBDIRECTORY(${CMAKE_SOURCE_DIR}/src/qtwrapper)
   ADD_DEFINITIONS(-DENABLE_LIBWRAP=true) # Use native calls (no dbus)
   if (NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
      ADD_DEFINITIONS(-Wno-unknown-pragmas)
   endif()
   SET(ENABLE_QT5 true) # Use Qt5
   MESSAGE(STATUS "Compiling with qtwrapper enabled, Qt5 enabled.")

   INCLUDE_DIRECTORIES (${CMAKE_SOURCE_DIR}/src/qtwrapper/)

   IF(${VERBOSE_IPC} MATCHES true)
      MESSAGE(STATUS "Adding more debug output")
      ADD_DEFINITIONS(-DVERBOSE_IPC=true)
   ENDIF()
ENDIF()

IF (${RING_FOUND} MATCHES "true")
   INCLUDE_DIRECTORIES(${ring_INCLUDE_DIRS})
ENDIF()

IF(NOT (${ENABLE_VIDEO} MATCHES false))
   MESSAGE(STATUS "VIDEO enabled")
   SET(ENABLE_VIDEO 1 CACHE BOOL "Enable video")
   add_definitions( -DENABLE_VIDEO=true )
ENDIF(NOT (${ENABLE_VIDEO} MATCHES false))

IF(NOT (${ENABLE_PLUGIN} MATCHES false))
   MESSAGE(STATUS "PLUGIN enabled")
   SET(ENABLE_PLUGIN 1 CACHE BOOL "Enable plugin")
   add_definitions( -DENABLE_PLUGIN=true )
ENDIF(NOT (${ENABLE_PLUGIN} MATCHES false))

# ADD_DEFINITIONS(-DQT_DISABLE_DEPRECATED_BEFORE=1)

if (CHK_FREEABLE_BEFORE_ERASE_ACCOUNT)
   ADD_DEFINITIONS(
      -DCHK_FREEABLE_BEFORE_ERASE_ACCOUNT
   )
endif ()

SET(GENERIC_LIB_VERSION "1.0.0")

INCLUDE_DIRECTORIES(SYSTEM ${QT_INCLUDES} )
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/src)
INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_BINARY_DIR})

IF(NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
    # Build dbus api
    IF(DEFINED RING_XML_INTERFACES_DIR)
        SET (dbus_xml_introspecs_path ${RING_XML_INTERFACES_DIR})
    ELSEIF(EXISTS "${RING_BUILD_DIR}/../bin/dbus")
        SET (dbus_xml_introspecs_path ${RING_BUILD_DIR}/../bin/dbus)
    ELSE()
        SET (dbus_xml_introspecs_path ${CMAKE_INSTALL_PREFIX}/share/dbus-1/interfaces)
    ENDIF()

    MESSAGE(STATUS "Using Ring DBus-XML interfaces in ${dbus_xml_introspecs_path}")
ENDIF()

#File to compile
SET( libringclient_LIB_SRCS
  #Data objects
  src/uri.cpp
  src/video/renderer.cpp

  #Models
  src/contactmodel.cpp
  src/newcallmodel.cpp
  src/newdevicemodel.cpp
  src/newcodecmodel.cpp
  src/conversationmodel.cpp
  src/database.cpp
  src/authority/daemon.cpp
  src/authority/storagehelper.cpp
  src/lrc.cpp
  src/newaccountmodel.cpp
  src/peerdiscoverymodel.cpp
  src/callbackshandler.cpp
  src/behaviorcontroller.cpp
  src/datatransfermodel.cpp
  src/newvideo.cpp
  src/shmrenderer.cpp
  src/directrenderer.cpp

  #Communication
  src/dbus/configurationmanager.cpp
  src/dbus/callmanager.cpp
  src/dbus/instancemanager.cpp
  src/dbus/videomanager.cpp
  src/dbus/presencemanager.cpp
  src/dbus/pluginmanager.cpp

  #Default interface implementations
  src/globalinstances.cpp
  src/pixmapmanipulatordefault.cpp
  src/dbuserrorhandlerdefault.cpp

  #Other
  src/avmodel.cpp
  src/pluginmodel.cpp
  src/namedirectory.cpp
  src/smartinfohub.cpp
  src/chatview.cpp
)

# Public API
SET( libringclient_LIB_HDRS
  src/uri.h
  src/globalinstances.h
  src/pixmapmanipulatordefault.h
  src/dbuserrorhandlerdefault.h
  src/smartinfohub.h
  src/vcard.h
  src/namedirectory.h
  src/shmrenderer.h
  src/directrenderer.h
)

SET(libringclient_api_LIB_HDRS
  src/api/interaction.h
  src/api/conversation.h
  src/api/contact.h
  src/api/call.h
  src/api/account.h
  src/api/chatview.h
  src/api/lrc.h
  src/api/avmodel.h
  src/api/pluginmodel.h
  src/api/newaccountmodel.h
  src/api/peerdiscoverymodel.h
  src/api/newcallmodel.h
  src/api/newcodecmodel.h
  src/api/newdevicemodel.h
  src/api/contactmodel.h
  src/api/conversationmodel.h
  src/api/profile.h
  src/api/behaviorcontroller.h
  src/api/datatransfermodel.h
  src/api/datatransfer.h
  src/api/newvideo.h
)

SET(libringclient_WEB_chatview
   src/web-chatview/.eslintrc.json
   src/web-chatview/chatview-gnome.css
   src/web-chatview/chatview.css
   src/web-chatview/chatview.html
   src/web-chatview/chatview.js
   src/web-chatview/jed.js
   src/web-chatview/linkify-html.js
   src/web-chatview/linkify-string.js
   src/web-chatview/linkify.js
   src/web-chatview/qwebchannel.js
   src/web-chatview/web.gresource.xml
)

SET(libringclient_video_LIB_HDRS
  src/video/renderer.h
  #The renderer implementations are not exported on purpose
)

SET(libringclient_interface_LIB_HDRS
  src/interfaces/pixmapmanipulatori.h
  src/interfaces/dbuserrorhandleri.h
)

SET( libringclient_extra_LIB_HDRS
  src/typedefs.h
  src/containerview.h
)

IF(${ENABLE_LIBWRAP} MATCHES true OR ${ENABLE_TEST} MATCHES true)
   # done this way because of bug in cmake 2.8
   # (not necessary in 3.0+)
ELSE()
   # presence manager interface
   SET ( presencemanager_xml  ${dbus_xml_introspecs_path}/cx.ring.Ring.PresenceManager.xml )

   SET( dbus_metatype_path "${CMAKE_CURRENT_SOURCE_DIR}/src/dbus/metatypes.h")

   SET_SOURCE_FILES_PROPERTIES(
      ${presencemanager_xml}
      PROPERTIES
      CLASSNAME PresenceManagerInterface
      INCLUDE ${dbus_metatype_path}
   )

   QT5_ADD_DBUS_INTERFACE(
      libringclient_LIB_SRCS
      ${presencemanager_xml}
      presencemanager_dbus_interface
   )

   # configuration manager interface
   SET ( configurationmanager_xml  ${dbus_xml_introspecs_path}/cx.ring.Ring.ConfigurationManager.xml )

   SET_SOURCE_FILES_PROPERTIES(
      ${configurationmanager_xml}
      PROPERTIES
      CLASSNAME ConfigurationManagerInterface
      INCLUDE ${dbus_metatype_path}
   )

=== daemon/src/CMakeLists.txt ===
################################################################################
# Source groups - src
################################################################################

# client|config|dring|hooks|im|jamidht|media|security|sip|transport|upnp

list (APPEND Source_Files
      "${CMAKE_CURRENT_SOURCE_DIR}/account.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/account.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/account_factory.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/account_factory.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/account_schema.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/archiver.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/archiver.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/array_size.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/base64.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/base64.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/buildinfo.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/call.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/call.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/call_factory.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/call_factory.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/compiler_intrinsics.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/conference.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/conference.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/data_transfer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/data_transfer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/enumclass_utils.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/fileutils.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/fileutils.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ftp_server.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ftp_server.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/generic_io.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ice_socket.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ice_transport.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ice_transport.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ip_utils.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ip_utils.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/logger.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/logger.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/manager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/manager.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/map_utils.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/noncopyable.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/peer_connection.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/peer_connection.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/preferences.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/preferences.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/rational.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/registration_states.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ring_api.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ring_types.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/rw_mutex.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/scheduled_executor.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/scheduled_executor.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/smartools.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/smartools.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/string_utils.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/string_utils.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/threadloop.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/threadloop.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/utf8_utils.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/utf8_utils.h"
)

if(MSVC)
   list (APPEND Source_Files
         "${CMAKE_CURRENT_SOURCE_DIR}/windirent.h"
         "${CMAKE_CURRENT_SOURCE_DIR}/winsyslog.c"
         "${CMAKE_CURRENT_SOURCE_DIR}/winsyslog.h"
   )
endif()

set (Source_Files ${Source_Files} PARENT_SCOPE)

add_subdirectory(client)
add_subdirectory(config)
add_subdirectory(dring)
add_subdirectory(im)
add_subdirectory(jamidht)
add_subdirectory(media)
add_subdirectory(security)
add_subdirectory(sip)
add_subdirectory(upnp)
add_subdirectory(plugin)

set (Source_Files__client ${Source_Files__client} PARENT_SCOPE)
set (Source_Files__config ${Source_Files__config} PARENT_SCOPE)
set (Source_Files__dring ${Source_Files__dring} PARENT_SCOPE)
set (Source_Files__hooks ${Source_Files__hooks} PARENT_SCOPE)
set (Source_Files__im ${Source_Files__im} PARENT_SCOPE)
set (Source_Files__jamidht ${Source_Files__jamidht} PARENT_SCOPE)
set (Source_Files__jamidht__eth__libdevcore ${Source_Files__jamidht__eth__libdevcore} PARENT_SCOPE)
set (Source_Files__jamidht__eth__libdevcrypto ${Source_Files__jamidht__eth__libdevcrypto} PARENT_SCOPE)
set (Source_Files__media ${Source_Files__media} PARENT_SCOPE)
set (Source_Files__media__audio ${Source_Files__media__audio} PARENT_SCOPE)
set (Source_Files__media__audio__sound ${Source_Files__media__audio__sound} PARENT_SCOPE)
set (Source_Files__media__video ${Source_Files__media__video} PARENT_SCOPE)
if(MSVC)
   if(WINDOWS_STORE)
      set (Source_Files__media__video__uwpvideo ${Source_Files__media__video__uwpvideo} PARENT_SCOPE)
   endif()
   set (Source_Files__media__audio__portaudio ${Source_Files__media__audio__portaudio} PARENT_SCOPE)
   set (Source_Files__media__video__winvideo ${Source_Files__media__video__winvideo} PARENT_SCOPE)
endif()
set (Source_Files__security ${Source_Files__security} PARENT_SCOPE)
set (Source_Files__sip ${Source_Files__sip} PARENT_SCOPE)
set (Source_Files__upnp ${Source_Files__upnp} PARENT_SCOPE)
set (Source_Files__upnp__protocol ${Source_Files__upnp__protocol} PARENT_SCOPE)
set (Source_Files__upnp__protocol__pupnp ${Source_Files__upnp__protocol__pupnp} PARENT_SCOPE)
set (Source_Files__upnp__protocol__natpmp ${Source_Files__upnp__protocol__natpmp} PARENT_SCOPE)
set (Source_Files__plugin ${Source_Files__plugin} PARENT_SCOPE)

=== plugins/GreenScreen/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# set the project name
set (ProjectName GreenScreen)
set (Version 1.0)

project(${ProjectName} VERSION ${Version})

set (DAEMON ./../../daemon)
set (PLUGIN_NAME GreenScreen)
set (JPL_FILE_NAME ${PLUGIN_NAME}.jpl)
set (DAEMON_SRC ${DAEMON}/src)
set (CONTRIB_PATH ${DAEMON}/contrib)
set (DESTINATION_PATH ./../build/)
set (PLUGINS_LIB ../lib)
set (JPL_DIRECTORY ${PROJECT_BINARY_DIR}/jpl)

if(WIN32)
	message(OS:\  WINDOWS\ ${CMAKE_SYSTEM_PROCESSOR})
	if (NOT ${CMAKE_CL_64})
		message( FATAL_ERROR "\nUse CMake only for x64 Windows" )
	endif()
	set (CONTRIB_PLATFORM_CURT x64)
	set (CONTRIB_PLATFORM ${CONTRIB_PLATFORM_CURT}-windows)
	set (LIBRARY_FILE_NAME ${PLUGIN_NAME}.dll)
	set (LIBS_DIR $ENV{HOME}/Documents/GITHUB/Libs)
	set (OPENCV $ENV{HOME}/Documents/GITHUB/opencv/build-bash/)
	set (FFMPEG ${CONTRIB_PATH}/build/ffmpeg/Build/win32/x64)
endif()

if(UNIX)
	message( FATAL_ERROR "\nUse CMake only for Windows! For linux or Android (linux host), use our bash scripts.\nPlese refer to documentation for more infos." )
	message(OS:\  LINUX\ ${CMAKE_SYSTEM_PROCESSOR})
	set (CONTRIB_PLATFORM_CURT ${CMAKE_SYSTEM_PROCESSOR})
	set (CONTRIB_PLATFORM ${CONTRIB_PLATFORM_CURT}-linux-gnu)
	set (LIBRARY_FILE_NAME lib${PLUGIN_NAME}.so)
	set (LIBS_DIR /home/${USER}/Libs)
endif()


message(Building:\   ${ProjectName}\   ${Version})
message(Build\ path:\ ${PROJECT_BINARY_DIR})
message(JPL\ assembling\ path:\ ${JPL_DIRECTORY})
message(JPL\ path:\ ${JPL_DIRECTORY}/../../../build/${ProjectName}/${JPL_FILE_NAME})

set(TENSORFLOW _tensorflow_cc)
set(model mModel-resnet50float.pb)
set(modelType .pb)
set(preferencesFile preferences-tfcc.json)
set(TFLIB libtensorflow_cc)
set(GPU -gpu61)

if (CPU)
	set(GPU )
	add_definitions(-DCPU)
	message(CPU\ BUILDING!)
endif()

if (TFLITE)
	add_definitions(-DTFLITE)
	set(TENSORFLOW _tensorflowLite)
	set(model mobilenet_v2_deeplab_v3_256_myquant.tflite)
	set(modelType .tflite)
	set(preferencesFile preferences-tflite.json)
	set(TFLIB libtensorflowlite)
	message(TFLITE\ BUILDING!)
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")

set(plugin_SRC main.cpp
			   pluginInference.cpp
			   pluginMediaHandler.cpp
			   pluginParameters.cpp
			   pluginProcessor.cpp
			   TFInference.cpp
			   videoSubscriber.cpp
			   )

set(plugin_HDR pluginInference.h
			   pluginMediaHandler.h
			   pluginParameters.h
			   pluginProcessor.h
			   TFInference.h
			   TFModels.h
			   videoSubscriber.h
			   ../lib/accel.h
			   ../lib/framescaler.h
			   ../lib/pluglog.h
			   )



# add the library
add_library(${ProjectName} SHARED ${plugin_SRC}
								  ${plugin_HDR}
								  )

target_include_directories(${ProjectName} PUBLIC ${PROJECT_BINARY_DIR}
												 ${PROJECT_SOURCE_DIR}
												 ${DAEMON_SRC}
												 ${CONTRIB_PATH}
												 ${CONTRIB_PATH}/${CONTRIB_PLATFORM}/include
												 ${CONTRIB_PATH}/${CONTRIB_PLATFORM}/include/opencv4
												 ${OPENCV}/install/include
												 ${FFMPEG}/include
												 ${PLUGINS_LIB}
												 ${LIBS_DIR}
												 ${LIBS_DIR}/${TENSORFLOW}/include
												 ${LIBS_DIR}/${TENSORFLOW}/include/third_party/eigen3
												 ${LIBS_DIR}/${TENSORFLOW}/include/flatbuffers
												 )
if (WIN32)
target_link_directories(${ProjectName} PUBLIC	${CONTRIB_PATH}
										${LIBS_DIR}/${TENSORFLOW}/lib/${CONTRIB_PLATFORM}
										${OPENCV}/install/x64/vc16/staticlib
										${FFMPEG}/bin
										${LIBS_DIR}
										${CONTRIB_PATH}/${CONTRIB_PLATFORM}/lib
										${CONTRIB_PATH}/${CONTRIB_PLATFORM}/lib/opencv4/3rdparty
										${LIBS_DIR}/${TENSORFLOW}/lib/${CONTRIB_PLATFORM}
										)

target_link_libraries(${ProjectName} PUBLIC swscale avutil libpng opencv_imgcodecs411 opencv_imgproc411 opencv_core411 ${TFLIB} zlib)
endif()

if (UNIX)
link_directories(${ProjectName} PUBLIC	${CONTRIB_PATH}
										${LIBS_DIR}/${TENSORFLOW}/lib/${CONTRIB_PLATFORM}
										${OPENCV}/install/x64/vc16/staticlib
										${FFMPEG}/bin
										${LIBS_DIR}
										${CONTRIB_PATH}/${CONTRIB_PLATFORM}/lib
										${CONTRIB_PATH}/${CONTRIB_PLATFORM}/lib/opencv4/3rdparty
										${LIBS_DIR}/${TENSORFLOW}/lib/${CONTRIB_PLATFORM}
										)
target_link_libraries(${ProjectName} PUBLIC swscale avutil libpng opencv_imgcodecs opencv_imgproc opencv_core ${TFLIB})
endif()

add_custom_command(
	TARGET ${ProjectName}
	PRE_BUILD
	COMMAND ${CMAKE_COMMAND} -E remove_directory -r ${JPL_DIRECTORY}
	COMMAND ${CMAKE_COMMAND} -E remove_directory -r ${JPL_DIRECTORY}/../../../build/${ProjectName}
	COMMAND ${CMAKE_COMMAND} -E make_directory ${JPL_DIRECTORY}/../../../build/${ProjectName}
	COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/data ${JPL_DIRECTORY}/data
	COMMAND ${CMAKE_COMMAND} -E copy_directory ${LIBS_DIR}/${TENSORFLOW}/lib/ ${JPL_DIRECTORY}/lib
	COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/modelsSRC/${model} ${JPL_DIRECTORY}/data/models
	COMMAND ${CMAKE_COMMAND} -E rename ${JPL_DIRECTORY}/data/models/${model} ${JPL_DIRECTORY}/data/models/mModel${modelType}
	COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/manifest.json ${JPL_DIRECTORY}
	COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/${preferencesFile} ${JPL_DIRECTORY}/data
	COMMAND ${CMAKE_COMMAND} -E rename ${JPL_DIRECTORY}/data/${preferencesFile} ${JPL_DIRECTORY}/data/preferences.json
	COMMENT "Assembling Plugin files"
)

if (WIN32)
	add_custom_command(
		TARGET ${ProjectName}
		POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/Release/${ProjectName}.lib ${JPL_DIRECTORY}/lib/${CONTRIB_PLATFORM}
		COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/Release/${LIBRARY_FILE_NAME} ${JPL_DIRECTORY}/lib/${CONTRIB_PLATFORM}
		COMMAND python ${PROJECT_SOURCE_DIR}/../assemblePlugin.py --plugins=GreenScreen
		COMMENT "Generating JPL archive"
	)
else()
	add_custom_command(
		TARGET ${ProjectName}
		POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_BINARY_DIR}/Release/${LIBRARY_FILE_NAME} ${JPL_DIRECTORY}/lib/${CONTRIB_PLATFORM}
		COMMAND python ${PROJECT_SOURCE_DIR}/../assemblePlugin.py --plugins=GreenScreen
		COMMENT "Generating JPL archive"
	)

endif()

=== daemon/src/client/CMakeLists.txt ===
################################################################################
# Source groups - client
################################################################################
list (APPEND Source_Files__client
      "${CMAKE_CURRENT_SOURCE_DIR}/callmanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/configurationmanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/datatransfer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/presencemanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ring_signal.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ring_signal.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/videomanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/videomanager.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/plugin_manager_interface.cpp"
)

set (Source_Files__client ${Source_Files__client} PARENT_SCOPE)

=== daemon/src/im/CMakeLists.txt ===
################################################################################
# Source groups - im
################################################################################
list (APPEND Source_Files__im
      "${CMAKE_CURRENT_SOURCE_DIR}/instant_messaging.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/instant_messaging.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/message_engine.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/message_engine.h"
)

set (Source_Files__im ${Source_Files__im} PARENT_SCOPE)

=== daemon/src/jamidht/CMakeLists.txt ===
################################################################################
# Source groups - jamidht
################################################################################

# eth/libdevcore|eth/libdevcrypto

list (APPEND Source_Files__jamidht
      "${CMAKE_CURRENT_SOURCE_DIR}/abstract_sip_transport.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/account_manager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/account_manager.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/accountarchive.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/accountarchive.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/archive_account_manager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/archive_account_manager.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/configkeys.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/connectionmanager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/connectionmanager.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/channeled_transport.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/channeled_transport.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/channeled_transfers.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/channeled_transfers.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/contact_list.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/contact_list.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/jami_contact.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/jamiaccount.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/jamiaccount.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/multiplexed_socket.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/multiplexed_socket.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/namedirectory.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/namedirectory.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/p2p.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/p2p.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/jami_contact.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/server_account_manager.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/server_account_manager.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/sips_transport_ice.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/sips_transport_ice.h"
)

set (Source_Files__jamidht ${Source_Files__jamidht} PARENT_SCOPE)

add_subdirectory("eth/libdevcore")
add_subdirectory("eth/libdevcrypto")

set (Source_Files__jamidht__eth__libdevcore ${Source_Files__jamidht__eth__libdevcore} PARENT_SCOPE)
set (Source_Files__jamidht__eth__libdevcrypto ${Source_Files__jamidht__eth__libdevcrypto} PARENT_SCOPE)

=== daemon/src/security/CMakeLists.txt ===
################################################################################
# Source groups - security
################################################################################
list (APPEND Source_Files__security
      "${CMAKE_CURRENT_SOURCE_DIR}/certstore.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/certstore.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/diffie-hellman.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/diffie-hellman.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/memory.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/memory.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/tls_session.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/tls_session.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/tlsvalidator.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/tlsvalidator.h"
)

set (Source_Files__security ${Source_Files__security} PARENT_SCOPE)

=== daemon/src/media/audio/CMakeLists.txt ===
################################################################################
# Source groups - audio
################################################################################

# alsa|coreaudio|jack|opensl|portaudio|pulseaudio|sound

list (APPEND Source_Files__media__audio
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_frame_resizer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_frame_resizer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_input.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_input.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_receive_thread.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_receive_thread.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_rtp_session.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_rtp_session.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_sender.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audio_sender.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiobuffer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiobuffer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiolayer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audiolayer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/audioloop.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/audioloop.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/dcblocker.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/dcblocker.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/resampler.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/resampler.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbuffer.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbuffer.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbufferpool.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/ringbufferpool.h"
      "${CMAKE_CURRENT_SOURCE_DIR}/tonecontrol.cpp"
      "${CMAKE_CURRENT_SOURCE_DIR}/tonecontrol.h"
)

if(NOT MSVC)
   list (APPEND Source_Files__media__audio
         "${CMAKE_CURRENT_SOURCE_DIR}/dsp.cpp"
         "${CMAKE_CURRENT_SOURCE_DIR}/dsp.h"
   )
endif()

set (Source_Files__media__audio ${Source_Files__media__audio} PARENT_SCOPE)

if(MSVC)
   add_subdirectory(portaudio)
   set (Source_Files__media__audio__portaudio ${Source_Files__media__audio__portaudio} PARENT_SCOPE)
endif()

add_subdirectory(sound)
set (Source_Files__media__audio__sound ${Source_Files__media__audio__sound} PARENT_SCOPE)

=== daemon/contrib/tarballs-unpacked/pjproject-2.10.tar.gz/pjproject-2.10/pjsip-apps/build/Makefile ===
include ../../build.mak
include $(PJDIR)/build/common.mak

export LIBDIR := ../lib
export BINDIR := ../bin

RULES_MAK := $(PJDIR)/build/rules.mak


###############################################################################
# Gather all flags.
#
export _CFLAGS 	:= $(CC_CFLAGS) $(OS_CFLAGS) $(HOST_CFLAGS) $(M_CFLAGS) \
		   $(PJ_CFLAGS) $(CFLAGS) $(CC_INC)../../pjsip/include \
		   $(CC_INC)../../pjlib/include \
		   $(CC_INC)../../pjlib-util/include \
		   $(CC_INC)../../pjnath/include \
		   $(CC_INC)../../pjmedia/include
export _CXXFLAGS:= $(_CFLAGS) $(CC_CXXFLAGS) $(OS_CXXFLAGS) $(M_CXXFLAGS) \
		   $(HOST_CXXFLAGS) $(CXXFLAGS)
export _LDFLAGS := $(CC_LDFLAGS) $(OS_LDFLAGS) $(M_LDFLAGS) $(HOST_LDFLAGS) \
		   $(APP_LDFLAGS) $(APP_LDLIBS) $(LDFLAGS) 

###############################################################################
# Defines for building PJSUA
#
export PJSUA_SRCDIR = ../src/pjsua
export PJSUA_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
            main.o pjsua_app.o pjsua_app_cli.o pjsua_app_common.o \
            pjsua_app_config.o pjsua_app_legacy.o
export PJSUA_CFLAGS += $(PJ_CFLAGS) $(CFLAGS)
export PJSUA_CXXFLAGS += $(PJ_CXXFLAGS) $(CFLAGS)
export PJSUA_LDFLAGS += $(PJ_LDFLAGS) $(PJ_LDLIBS) $(LDFLAGS)
ifeq ($(EXCLUDE_APP),0)
export PJSUA_EXE:=pjsua-$(TARGET_NAME)$(HOST_EXE)
endif

###############################################################################
# Defines for building pjsystest
#
export PJSYSTEST_SRCDIR = ../src/pjsystest
export PJSYSTEST_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
			systest.o main_console.o
export PJSYSTEST_CFLAGS += $(PJ_CFLAGS) $(CFLAGS)
export PJSYSTEST_CXXFLAGS += $(PJ_CXXFLAGS) $(CFLAGS)
export PJSYSTEST_LDFLAGS += $(PJ_LDFLAGS) $(PJ_LDLIBS) $(LDFLAGS)
ifeq ($(EXCLUDE_APP),0)
export PJSYSTEST_EXE:=pjsystest-$(TARGET_NAME)$(HOST_EXE)
endif

export CC_OUT CC AR RANLIB HOST_MV HOST_RM HOST_RMDIR HOST_MKDIR OBJEXT LD LDOUT 

TARGETS := $(PJSUA_EXE) $(PJSYSTEST_EXE) samples

all: $(TARGETS)

swig:
	$(MAKE) -C ../src/swig
	
doc:

dep: depend
distclean: realclean

.PHONY: all dep depend clean realclean distclean
.PHONY: $(TARGETS)
.PHONY: $(PJSUA_EXE) $(PJSYSTEST_EXE)

pjsua: $(PJSUA_EXE)
$(PJSUA_EXE):
	$(MAKE) -f $(RULES_MAK) APP=PJSUA app=pjsua $(subst /,$(HOST_PSEP),$(BINDIR)/$@)
	@if echo "$(TARGET_NAME)" | grep -q "apple-darwin_ios$$"; then \
	  for F in $(filter %$(TARGET_NAME).a,$(PJ_LIBXX_FILES)); do \
	    if test -f $$F; then \
	      tmp=`echo $${F##*/} | sed -e "s/\-$(TARGET_NAME)\.a/.a/"`; \
	      ln -sf $$F ../src/pjsua/ios/$$tmp; \
	    fi; \
	  done; \
	fi;

pjsystest: $(PJSYSTEST_EXE)
$(PJSYSTEST_EXE):
	$(MAKE) -f $(RULES_MAK) APP=PJSYSTEST app=pjsystest $(subst /,$(HOST_PSEP),$(BINDIR)/$@)

samples:
	$(MAKE) -f Samples.mak

.PHONY: pjsua.ko
pjsua.ko:
	$(MAKE) -f $(RULES_MAK) APP=PJSUA app=pjsua $(subst /,$(HOST_PSEP),$(LIBDIR)/$@)

clean depend realclean:
	$(MAKE) -f $(RULES_MAK) APP=PJSUA app=pjsua $@
	$(MAKE) -f $(RULES_MAK) APP=PJSYSTEST app=pjsystest $@
	$(MAKE) -f Samples.mak $@
	@if test "$@" = "depend"; then \
	  echo '$(BINDIR)/$(PJSUA_EXE): $(APP_LIB_FILES)' >> .pjsua-$(TARGET_NAME).depend; \
	  echo '$(BINDIR)/$(PJSYSTEST_EXE): $(APP_LIB_FILES)' >> .pjsystest-$(TARGET_NAME).depend; \
	fi
	@if echo "$(TARGET_NAME)" | grep -q "apple-darwin_ios$$"; then \
	  for F in $(filter %$(TARGET_NAME).a,$(PJ_LIBXX_FILES)); do \
	    tmp=`echo $${F##*/} | sed -e "s/\-$(TARGET_NAME)\.a/.a/"`; \
	    rm -f ../src/pjsua/ios/$$tmp; \
	  done; \
	fi;

=== daemon/contrib/tarballs-unpacked/pjproject-2.10.tar.gz/pjproject-2.10/pjsip-apps/src/swig/csharp/Makefile ===
include ../../../../build.mak
include ../../../../build/common.mak

ifneq ($(findstring android,$(TARGET_NAME)),)
    OS=android
else
    ifneq ($(findstring ios,$(TARGET_NAME)),)
	OS=ios
    endif
endif
SWIG_FLAGS=-I../../../../pjlib/include \
		   -I../../../../pjlib-util/include \
		   -I../../../../pjmedia/include \
		   -I../../../../pjsip/include \
		   -I../../../../pjnath/include -c++ 
SRC_DIR=../../../../pjsip/include
SRCS=$(SRC_DIR)/pjsua2/endpoint.hpp $(SRC_DIR)/pjsua2/types.hpp

SWIG_FLAGS += -w312

PROJ_NAME=pjsua2xamarin
OUT_DIR=$(PROJ_NAME)/$(PROJ_NAME)/pjsua2
NAMESPACE=$(PROJ_NAME).pjsua2

ARCH=$(TARGET_ARCH)

ifeq ($(OS),android)
    LIBPJSUA2_DIR=$(PROJ_NAME)/Droid/lib/$(ARCH)
    LIBPJSUA2=$(LIBPJSUA2_DIR)/libpjsua2.so
endif
ifeq ($(OS),ios)
    LIBPJSUA2_DIR=$(PROJ_NAME)/iOS/lib/$(ARCH)
    LIBPJSUA2=$(LIBPJSUA2_DIR)/libpjsua2.a
endif

# Build settings
MY_CFLAGS	 := $(PJ_CXXFLAGS) $(CFLAGS)
MY_LDFLAGS	 := $(PJ_LDXXFLAGS) $(PJ_LDXXLIBS) $(LDFLAGS)

.PHONY: all install uninstall

all: $(LIBPJSUA2) sample

$(LIBPJSUA2): $(OUT_DIR)/pjsua2_wrap.o
	mkdir -p $(LIBPJSUA2_DIR)
ifeq ($(OS),android)
	$(PJ_CXX) -shared -o $(LIBPJSUA2) $(OUT_DIR)/pjsua2_wrap.o \
		$(MY_CFLAGS) $(MY_LDFLAGS)
endif
ifeq ($(OS),ios)
	$(AR) $(LIBPJSUA2) $(AR_FLAGS) $(OUT_DIR)/pjsua2_wrap.o $(PJ_LIBXX_FILES)
endif

$(OUT_DIR)/pjsua2_wrap.o: $(OUT_DIR)/pjsua2_wrap.cpp
	$(PJ_CXX) -c $(OUT_DIR)/pjsua2_wrap.cpp -o $(OUT_DIR)/pjsua2_wrap.o \
		$(MY_CFLAGS)

$(OUT_DIR)/pjsua2_wrap.cpp: ../pjsua2.i ../symbols.i Makefile $(SRCS)
	mkdir -p $(OUT_DIR)
	swig $(SWIG_FLAGS) -namespace $(NAMESPACE) -csharp -o $(OUT_DIR)/pjsua2_wrap.cpp ../pjsua2.i
	
sample: sample.cs
	@echo "Copying sample code..."
	cp sample.cs $(PROJ_NAME)/$(PROJ_NAME)

clean distclean realclean:
	rm -rf $(OUT_DIR)/*
	rm -rf $(LIBPJSUA2_DIR)/*

install:

uninstall:

=== daemon/contrib/tarballs-unpacked/pjproject-2.10.tar.gz/pjproject-2.10/pjsip-apps/src/swig/java/Makefile ===
include ../../../../build.mak
include ../../../../build/common.mak

SWIG_FLAGS=-I../../../../pjlib/include \
		   -I../../../../pjlib-util/include \
		   -I../../../../pjmedia/include \
		   -I../../../../pjsip/include \
		   -I../../../../pjnath/include -c++ 
SRC_DIR=../../../../pjsip/include
SRCS=$(SRC_DIR)/pjsua2/endpoint.hpp $(SRC_DIR)/pjsua2/types.hpp

ifneq ($(findstring android,$(TARGET_NAME)),)
 OS=android
 ifeq ("$(JAVA_HOME)","")
   # Set dummy JAVA_HOME as JNI is bundled in Android NDK, only need javac here
   JAVA_HOME := $(dir $(shell which javac))
 endif
else
 ifneq ($(findstring darwin,$(TARGET_NAME)),)
  OS=darwin
 endif
endif

OUT_DIR=output
ifeq ($(OS),Windows_NT)
  LIBPJSUA2_SO=$(OUT_DIR)/pjsua2.dll
else
  ifeq ($(OS),darwin)
    LIBPJSUA2_SO=$(OUT_DIR)/libpjsua2.jnilib
  else
    ifeq ($(OS),android)
      LIBPJSUA2_SO=android/app/src/main/jniLibs/$(TARGET_ARCH)/libpjsua2.so
    else
      LIBPJSUA2_SO=$(OUT_DIR)/libpjsua2.so
    endif
  endif
endif

# Get JDK location
ifeq ("$(JAVA_HOME)","")

  verify_jdk  = $(shell test -d $(1)/include && test -d $(1)/lib && \
                	echo inclib1) \
                $(shell test -d $(1)/Headers && test -d $(1)/Libraries && \
			echo inclib2) \
                $(shell test -x $(1)/bin/javac && echo bin1) \
                $(shell test -x $(1)/Commands/javac && echo bin2) \
                $(shell test -x $(1)/javac && echo bin3)

  get_java_inc = $(if $(findstring inclib1,$(1)),$(2)/include,\
		 $(if $(findstring inclib2,$(1)),$(2)/Headers,))
  get_java_lib = $(if $(findstring inclib1,$(1)),$(2)/lib,\
		 $(if $(findstring inclib2,$(1)),$(2)/Libraries,))
  get_java_bin = $(if $(findstring bin1,$(1)),$(2)/bin,\
		 $(if $(findstring bin2,$(1)),$(2)/Commands,\
		 $(if $(findstring bin3,$(1)),$(2),)))


  # Check with 'which javac'
  WHICH_JAVAC := $(shell which javac)
  ifneq ($(WHICH_JAVAC),)
    WHICH_JAVAC := $(dir $(realpath $(WHICH_JAVAC)))
    WHICH_JAVAC := $(patsubst %/bin/,%,$(WHICH_JAVAC))
    TMP_RES := $(call verify_jdk,$(WHICH_JAVAC))
    ifneq ($(findstring inclib,$(TMP_RES)),)
      JAVA_HOME := $(WHICH_JAVAC)
      JAVA_INC  := $(call get_java_inc,$(TMP_RES),$(JAVA_HOME))
      JAVA_LIB  := $(call get_java_lib,$(TMP_RES),$(JAVA_HOME))
    endif
  endif

  # MacOS specifics
  ifeq ($(OS)$(JAVA_HOME),darwin)

    # Check with '/usr/libexec/java_home'
    # (see https://developer.apple.com/library/mac/qa/qa1170/_index.html)
    TMP_PATH := $(shell /usr/libexec/java_home)
    ifneq ("$(TMP_PATH)","")
      TMP_RES := $(call verify_jdk,$(TMP_PATH))
      ifneq ($(findstring inclib,$(TMP_RES)),)
        JAVA_HOME := $(TMP_PATH)
        JAVA_INC  := $(call get_java_inc,$(TMP_RES),$(JAVA_HOME))
        JAVA_LIB  := $(call get_java_lib,$(TMP_RES),$(JAVA_HOME))
      endif
    endif

    ifeq ($(JAVA_HOME),)
      # Check '/System/Library/Frameworks/JavaVM.framework'
      FIXED_PATH := /System/Library/Frameworks/JavaVM.framework
      TMP_RES := $(call verify_jdk,$(FIXED_PATH))
      ifneq ($(findstring inclib,$(TMP_RES)),)
        JAVA_HOME := $(FIXED_PATH)
        JAVA_INC  := $(call get_java_inc,$(TMP_RES),$(JAVA_HOME))
        JAVA_LIB  := $(call get_java_lib,$(TMP_RES),$(JAVA_HOME))
      endif
    endif

  endif

  ifneq ($(findstring bin,$(TMP_RES)),)
    JAVA_BIN := $(call get_java_bin,$(TMP_RES),$(JAVA_HOME))
  endif

#  $(info TMP_RES = $(TMP_RES))
#  $(info JAVA_HOME = $(JAVA_HOME))
#  $(info JAVA_INC  = $(JAVA_INC))
#  $(info JAVA_LIB  = $(JAVA_LIB))
#  $(info JAVA_BIN  = $(JAVA_BIN))
#  $(error done)

  ifeq ("$(JAVA_HOME)","")
    $(error Cannot determine JDK include/library path. \
            Please define JAVA_HOME envvar)
  endif

  ifeq ("$(JAVA_BIN)","")
    JAVA_BIN := $(JAVA_HOME)/bin
    $(warning Cannot determine JDK binary path. Set to $(JAVA_BIN))
  endif

else

  JAVA_INC := $(JAVA_HOME)/include
  JAVA_LIB := $(JAVA_HOME)/lib
  ifeq (exists,$(shell test -d "$(JAVA_HOME)/bin" && echo exists))
    JAVA_BIN := $(JAVA_HOME)/bin
  else
    JAVA_BIN := $(JAVA_HOME)
  endif

endif

# Env settings, e.g: path to SWIG, JDK, java(.exe), javac(.exe)
MY_SWIG		 := swig
MY_JAVA	 	 := "$(JAVA_BIN)/java"
MY_JAVAC	 := "$(JAVA_BIN)/javac"
ifneq ($(OS),android)
  MY_JNI_CFLAGS  := -I"$(JAVA_INC)" -I"$(JAVA_INC)/win32" \
		    -I"$(JAVA_INC)/linux" -I"$(JAVA_INC)/darwin" -I.
  MY_JNI_LDFLAGS := -L"$(JAVA_LIB)"
endif

# OS specific
ifeq ($(OS),Windows_NT)
  MY_JNI_LDFLAGS += -Wl,--kill-at
else
  MY_JNI_CFLAGS	 += -fPIC
  ifeq ($(OS),android)
    MY_JNI_CFLAGS+= -D__ANDROID__
    MY_JNI_LDFLAGS+= -Wl,-soname,libpjsua2.so
    SWIG_FLAGS+= -D__ANDROID__
  endif
endif

# Build settings
MY_CFLAGS	 := $(PJ_CXXFLAGS) $(MY_JNI_CFLAGS) $(CFLAGS)
MY_LDFLAGS	 := $(PJ_LDXXFLAGS) $(PJ_LDXXLIBS) $(MY_JNI_LDFLAGS) $(LDFLAGS)
MY_PACKAGE_NAME	 := org.pjsip.pjsua2
ifeq ($(OS),android)
  MY_PACKAGE_PATH  := android/app/src/main/java/$(subst .,/,$(MY_PACKAGE_NAME))
else
  MY_PACKAGE_PATH  := $(OUT_DIR)/$(subst .,/,$(MY_PACKAGE_NAME))
endif

MY_APP_JAVA := android/app/src/main/java/$(subst .,/,$(MY_PACKAGE_NAME))/app/MyApp.java

.PHONY: all java install uninstall

all: $(LIBPJSUA2_SO) java

$(LIBPJSUA2_SO): $(OUT_DIR)/pjsua2_wrap.o
ifeq ($(OS),android)
	mkdir -p android/app/src/main/jniLibs/$(TARGET_ARCH)
	# copy libc++_shared.so manually
	cp -f ${ANDROID_NDK_ROOT}/sources/cxx-stl/llvm-libc++/libs/${TARGET_ARCH}/libc++_shared.so android/app/src/main/jniLibs/$(TARGET_ARCH)
endif
	$(PJ_CXX) -shared -o $(LIBPJSUA2_SO) $(OUT_DIR)/pjsua2_wrap.o \
		$(MY_LDFLAGS)

$(OUT_DIR)/pjsua2_wrap.o: $(OUT_DIR)/pjsua2_wrap.cpp Makefile
	$(PJ_CXX) -c $(OUT_DIR)/pjsua2_wrap.cpp -o $(OUT_DIR)/pjsua2_wrap.o \
		$(MY_CFLAGS)

$(OUT_DIR)/pjsua2_wrap.cpp: ../pjsua2.i ../symbols.i $(SRCS)
	mkdir -p $(MY_PACKAGE_PATH)
	mkdir -p $(OUT_DIR)
	swig $(SWIG_FLAGS) -java  -package $(MY_PACKAGE_NAME) \
		-outdir $(MY_PACKAGE_PATH) \
		-o $(OUT_DIR)/pjsua2_wrap.cpp ../pjsua2.i

clean distclean realclean:
	rm -rf $(LIBPJSUA2_SO) $(OUT_DIR)/* \
		$(MY_PACKAGE_PATH)/*.java $(MY_PACKAGE_PATH)/*.class

java: $(MY_PACKAGE_PATH)/Error.class $(MY_PACKAGE_PATH)/test.class $(MY_PACKAGE_PATH)/sample.class
ifneq (,$(findstring PJMEDIA_VIDEO_DEV_HAS_ANDROID=1,$(ANDROID_CFLAGS)))
	@echo "Copying Android camera helper components..."
	cp $(PJDIR)/pjmedia/src/pjmedia-videodev/android/PjCamera*.java $(MY_PACKAGE_PATH)/..
endif

$(MY_PACKAGE_PATH)/Error.class: $(MY_PACKAGE_PATH)/Error.java
	$(MY_JAVAC) -d $(OUT_DIR) $(MY_PACKAGE_PATH)/*.java $(MY_APP_JAVA)

$(MY_PACKAGE_PATH)/test.class: test.java
	$(MY_JAVAC) -d $(OUT_DIR) -classpath "$(OUT_DIR)" test.java
	
$(MY_PACKAGE_PATH)/sample.class: sample.java
	$(MY_JAVAC) -d $(OUT_DIR) -classpath "$(OUT_DIR)" sample.java
	@# Build javafx sample app
	@# $(MY_JAVAC) -d $(OUT_DIR) -classpath "$(OUT_DIR)" sample2.java

test:
	@# Need to specify classpath and library path, alternatively,
	@# they can be set via CLASSPATH and java.library.path env settings
	$(MY_JAVA) -cp "$(OUT_DIR)" -Djava.library.path="$(OUT_DIR)" test
	
sample:
	@# Need to specify classpath and library path, alternatively,
	@# they can be set via CLASSPATH and java.library.path env settings
	$(MY_JAVA) -cp "$(OUT_DIR)" -Djava.library.path="$(OUT_DIR)" \
		org.pjsip.pjsua2.app.sample	
	@# This is for sample2 app
	@# $(MY_JAVA) -cp "$(OUT_DIR)" -Djava.library.path="$(OUT_DIR)" \
	@#	org.pjsip.pjsua2.app.sample2	        

install:
uninstall:

=== debian/changelog ===
ring (20210112.2.b757bac~ds1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 28 Jun 2021 12:31:32 -0700

ring (20210112.2.b757bac~ds1-1) unstable; urgency=medium

  [ Alexandre Viau ]
  * New upstream snapshot.
  * d/copyright: ignore ONNX Runtime.

  [ Thorsten Alteholz ]
  * CVE-2020-15260 (Closes: #986815)
    Adding remote hostname authentication when reusing transport
    connections to the same IP address.
  * CVE-2021-21375
    The embedded copy of pjproject is affected by this CVE.
    Due to bad handling of two consecutive crafted answers to an INVITE,
    the attacker is able to crash the server resulting in a denial of
    service.

  [ Amin Bandali ]
  * d/patches: add upstream patch for fixing SIP calls to zoom.
    (Closes: #980571)
  * d/patches: add patch for improving the appstream description.

  [ Bruno Kleinert ]
  * d/control: improve package description. (Closes: #979492)

 -- Alexandre Viau <aviau@debian.org>  Sun, 17 Jan 2021 16:39:58 -0500

=== debian/control ===
Source: ring
Section: comm
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>
Build-Depends: autoconf,
               automake,
               cmake,
               debhelper (>= 9),
               gettext,
               libarchive-dev,
               libargon2-0-dev,
               libasio-dev,
               libasound2-dev,
               libavcodec-dev,
               libavdevice-dev,
               libavformat-dev,
               libavutil-dev (>= 7:3.4.2),
               libayatana-appindicator3-dev | libappindicator3-dev,
               libcanberra-gtk3-dev,
               libclutter-1.0-dev,
               libclutter-gtk-1.0-dev,
               libcrypto++-dev,
               libdbus-1-dev,
               libdbus-c++-dev,
               libexpat1-dev,
               libfmt-dev,
               libglib2.0-dev,
               libgnutls28-dev (>= 3.4.14),
               libgsm1-dev,
               libgtk-3-dev,
               libhttp-parser-dev,
               libjsoncpp-dev,
               libmsgpack-dev (>= 1.4.2),
               libnatpmp-dev,
               libnm-dev,
               libnotify-dev,
               libopendht-dev (>= 2.1.1),
               libopus-dev,
               libpcre3-dev,
               libpulse-dev,
               libqrencode-dev,
               libsamplerate0-dev,
               libsecp256k1-dev,
               libsndfile1-dev,
               libspeex-dev,
               libspeexdsp-dev,
               libssl-dev,
               libswscale-dev,
               libtool,
               libudev-dev,
               libupnp-dev,
               libva-dev,
               libvdpau-dev,
               libwebkit2gtk-4.0-dev,
               libxext-dev,
               libxfixes-dev,
               libyaml-cpp-dev,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               uuid-dev,
               yasm
Standards-Version: 4.5.1
Homepage: https://jami.net
Vcs-Git: https://salsa.debian.org/pkg-voip-team/ring.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/ring
Rules-Requires-Root: no

Package: jami
Architecture: any
Depends: jami-daemon (=${binary:Version}),
         libqt5sql5-sqlite,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: ring (<< 20190101.3.5315d84~)
Breaks: ring (<< 20190101.3.5315d84~)
Description: Secure and distributed voice, video, and chat platform - desktop client
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree Jami provides similar functionality like Telegram,
 BigBlueButton, Jitsi Meet, etc do.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami desktop client: jami-gnome.

Package: jami-daemon
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: ring-daemon (<< 20190101.3.5315d84~)
Breaks: ring-daemon (<< 20190101.3.5315d84~)
Description: Secure and distributed voice, video and chat platform - daemon
 Jami is an end-to-end encrypted secure and distributed voice, video,
 and chat communication platform that requires no central server and
 leaves the power of privacy and freedom in the hands of users.
 .
 To some degree Jami provides similar functionality like Telegram,
 BigBlueButton, Jitsi Meet, etc do.
 .
 Jami supports the following key features:
   * One-to-one conversations
   * File sharing
   * Audio calls and conferences
   * Video calls and conferences
   * Screen sharing in video calls and conferences
   * Recording and sending audio messages
   * Recording and sending video messages
   * Functioning as a SIP phone software
 .
 Jami client applications for several desktop and mobile operating
 systems and platforms are available on https://jami.net/, making
 Jami an interoperable, cross-platform communication framework.
 .
 This package contains the Jami daemon: dring.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Build with LFS (See #913186)
CFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CXXFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

# Number of CPUS
NO_CPUS=$(shell nproc)
ifeq ($(NO_CPUS),0)
NO_CPUS=1
endif

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
	###############################################
	## Re-create tarballs from tarballs-unpacked ##
	###############################################
	mkdir -p daemon/contrib/tarballs

	# Create tarballs
	for i in $(CURDIR)/daemon/contrib/tarballs-unpacked/*; do \
		projectname=`basename $$i` && \
		cd $$i && tar -caf ../../tarballs/$$projectname * && \
		echo "Repacked $$projectname"; \
	done

	###########################
	## daemon configure ##
	###########################
	mkdir -p daemon/contrib/native
	cd daemon/contrib/native && \
        ../bootstrap \
				--disable-downloads \
				--no-checksums \
				--disable-ogg \
				--disable-flac \
				--disable-gmp \
				--disable-vorbis \
				--disable-vorbisenc \
				--disable-speex \
				--disable-sndfile \
				--disable-gsm \
				--disable-speexdsp \
				--disable-asio \
				--disable-boost \
				--disable-cryptopp \
				--disable-ffmpeg \
				--disable-restbed \
				--disable-vpx \
				--disable-x264 \
				--disable-yaml-cpp \
				--disable-opendht \
				--disable-gnutls \
				--disable-dbus-cpp \
				--disable-secp256k1 \
				--disable-upnp \
				--disable-asio \
				--disable-restinio \
				--disable-fmt \
				--disable-http_parser \
				--disable-libarchive \
				--disable-natpmp && \
		make list && \
		make -j$(NO_CPUS) V=1
	cd daemon && \
		./autogen.sh && \
		./configure \
				--prefix=/usr \
				--disable-shared

	#############################
	## libringclient configure ##
	#############################
	cd lrc && \
		mkdir build && \
		cd build && \
		cmake  \
			-DRING_BUILD_DIR=$(CURDIR)/daemon/src \
			-DCMAKE_INSTALL_PREFIX=/usr \
			-DCMAKE_BUILD_TYPE=Debug \
			..

	############################
	## gnome client configure ##
	############################
	cd client-gnome && \
		mkdir build && \
		cd build && \
		cmake \
			-DCMAKE_INSTALL_PREFIX=/usr \
			-DLibRingClient_PROJECT_DIR=/$(CURDIR)/lrc \
			-DGSETTINGS_LOCALCOMPILE=OFF \
			..

	dh_auto_configure

override_dh_auto_build:
	#######################
	## Ring Daemon build ##
	#######################
	make -C daemon -j$(NO_CPUS) V=1
	pod2man daemon/man/dring.pod > daemon/dring.1

	#########################
	## libringclient build ##
	#########################
	make -C lrc/build -j$(NO_CPUS) V=1

	########################
	## gnome client build ##
	########################
	make -C client-gnome/build LDFLAGS="-lpthread" -j$(NO_CPUS) V=1

override_dh_auto_clean:
	################################
	## Generated contrib tarballs ##
	################################
	rm -rfv daemon/contrib/tarballs

	#######################
	## daemon clean ##
	#######################
	if [ -f daemon/contrib/native/Makefile ]; then make -C daemon/contrib/native distclean; fi
	rm -rfv daemon/contrib/native
	rm -rfv daemon/dring.1

	#########################
	## libringclient clean ##
	#########################
	if [ -f lrc/build/Makefile ]; then make -C lrc/build clean; fi
	rm -rfv lrc/build

	########################
	## gnome client clean ##
	########################
	if [ -f client-gnome/build/Makefile ]; then make -C client-gnome/build clean; fi
	rm -rfv client-gnome/build

override_dh_auto_install:
	#########################
	## daemon install ##
	#########################
	cd daemon && make DESTDIR=$(CURDIR)/debian/jami-daemon install
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/include
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/*.a
	rm -rfv $(CURDIR)/debian/jami-daemon/usr/lib/*.la

	###########################
	## libringclient install ##
	###########################
	cd lrc/build && make DESTDIR=$(CURDIR)/debian/jami install
	rm -rfv $(CURDIR)/debian/jami/usr/include

	# This is a symlink, should be in -dev package
	rm -v $(CURDIR)/debian/jami/usr/lib/libringclient.so

	# cmake files
	rm -rfv $(CURDIR)/debian/jami/usr/lib/cmake

	##########################
	## gnome client install ##
	##########################
	cd client-gnome/build && make DESTDIR=$(CURDIR)/debian/jami install

	# Remove jami binary: it is not needed for now
	rm $(CURDIR)/debian/jami/usr/bin/jami

tmpdir:= $(shell mktemp -d)
workdir:= $(shell pwd)
PKD := $(abspath $(dir $(MAKEFILE_LIST)))
version_to_download := $(shell dpkg-parsechangelog -ldebian/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\~ds.+)(?:\-\d+.*)};')

override_dh_strip:
	dh_strip --no-automatic-dbgsym

# Repacks the tarball with contrib tarballs unpacked.
get-orig-source:
	# Download ring tarball
	if [ -n "$$GET_ORIG_SOURCE_OVERRIDE_USCAN_TARBALL" ]; then \
	    mv $$GET_ORIG_SOURCE_OVERRIDE_USCAN_TARBALL ${tmpdir}; \
	else \
	    uscan --rename --destdir=${tmpdir} --download-version ${version_to_download} ;\
	fi

	# Unpack ring tarball
	tar -C ${tmpdir} -xf ${tmpdir}/*.tar.*

	# Remove original tarball
	rm ${tmpdir}/*.tar.*

	# Unpack all of the orig tarballs into tarballs-unpacked
	mkdir ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked
	for i in `find ${tmpdir}/ring-project/daemon/contrib/tarballs/ -name "*.tar.*"`; do \
		projectname=`basename $$i` && \
		mkdir ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/$$projectname && \
		tar -C ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/$$projectname -xf $$i && \
		echo "Unpacked $$projectname"; \
    done

	###################
	## Exclude files ##
	###################
	# This does not exclude everything that we need to exclude.
	# debian/copyright's File-Excluded section also excludes files.

    ## pjproject
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/g7221 # non-distributable (requires a license from Polycom)
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/ilbc # non distributable (the version included with pjproject)
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/milenage # non distributable
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/BaseClasses # non distributable (?)
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/portaudio # not needed
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/speex # not needed
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/mp3 # not needed
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/gsm # not needed
	rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/bdsound # not needed
	#rm -rf  ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/third_party/srtp # not needed
	rm -f ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/pjmedia/src/pjmedia-audiodev/s60_g729_bitstream.h # non distributable
	rm -rf ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/build/vs # not needed, VisualStudio files.
	rm -f ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/pjsip-apps/src/swig/java/android/gradle/wrapper/* # not needed
	rm -f ${tmpdir}/ring-project/daemon/contrib/tarballs-unpacked/pjproject-*/pjproject-*/pjsip-apps/src/pjsua/android/gradle/wrapper/* # not needed

	# Remove all contrib tarballs
	rm -rf ${tmpdir}/ring-project/daemon/contrib/tarballs

	# Create the new tarball
	cd  ${tmpdir} && tar -czf ${workdir}/ring_${version_to_download}~ds1.orig.tar.gz ring-project
